# Source for file Xml.php

Documentation is available at Xml.php

1. <?php
2. /*
3. * $Id: Xml.php 1838 2007-06-26 00:58:21Z nicobn $
4. *
5. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6. * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7. * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8. * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9. * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10. * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11. * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12. * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13. * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14. * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15. * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16. *
17. * This software consists of voluntary contributions made by many individuals
18. * and is licensed under the LGPL. For more information, see
19. * <http://www.phpdoctrine.com>.
20. */
22. /**
23. * class Doctrine_Export_Schema_Xml
24. *
25. * @package Doctrine
26. * @category Object Relational Mapping
27. * @link www.phpdoctrine.com
28. * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
29. * @version $Revision: 1838 $
30. * @author Nicolas Bérard-Nault <nicobn@gmail.com>
31. */
32. class Doctrine_Export_Schema_Xml extends Doctrine_Export_Schema
33. {
34. /**
35. * build
36. *
37. * Build the schema xml string to be dumped to file
38. *
39. * @param string $array
40. * @return void
41. */
42. public function build($array)
43. {
44. $xml = new SimpleXMLElement();
46. foreach ($array as $tableName => $fields) {
47. $table = $xml->addChild('table');
48. $name = $table->addChild('name', $tableName);
49. $declaration = $table->addChild('declaration');
51. foreach ($fields as $fieldName => $properties) {
52. $field = $declaration->addChild('field');
53. $field->addChild('name', $fieldName);
55. foreach ($properties as $key => $value) {
56. $field->addChild($key, $value);
57. }
58. }
59. }
61. return $xml->asXml();
62. }
64. /**
65. * dump
66. *
67. * Dump the array to the schema file
68. *
69. * @param string $array
70. * @param string $schema
71. * @return void
72. */
73. public function dump($array, $schema)
74. {
75. $xml = $this->build($array);
77. file_put_contents($schema, $xml);
78. }
79. }